// ---------------------------------------------------------------------------
// GLWC.cpp
// Copyright (c) 20065 NAKA Takatoshi. All rights reserved.
// ---------------------------------------------------------------------------
#include "stdafx.h"
#include <windows.h>
//#include <GL/gl.h>
//#include <GL/glu.h>
#include <glut.h>
#include "GLWC.h"

namespace glcall
{
	// RXgN^
	Glwc::Glwc( HWND hWnd )
	{
		_hWnd = hWnd;
		_hDC = GetDC(_hWnd);
		
		// sNZ tH[}bgݒ肷
		if( 0 != SetupPixelFormat( _hDC ) ) return;

		// _O ReLXg̍쐬 
		_hglrc = wglCreateContext (_hDC); 
	}

	// fXgN^
	Glwc::~Glwc()
	{
		// _O ReLXgJg͂B
		wglMakeCurrent (NULL, NULL) ; 
		 
		// _O ReLXg̍폜
		wglDeleteContext (_hglrc);

		// GetDC ŊmۂJ
		ReleaseDC( _hWnd, _hDC );
	}
	

	// sNZ tH[}bgݒ肷
	int Glwc::SetupPixelFormat( HDC hdc )
	{
		int pixelformat;

		static PIXELFORMATDESCRIPTOR pfd = {
			sizeof (PIXELFORMATDESCRIPTOR),		// \̂̃TCY
			1,									// OpenGL o[W
			PFD_DRAW_TO_WINDOW |				// EBhEX^C
			PFD_SUPPORT_OPENGL |				// OpenGL g
			PFD_DOUBLEBUFFER,					// _uobt@
			PFD_TYPE_RGBA,						// sNZ̃J[f[^
			32,									// F̃rbg
			0, 0, 0, 0, 0, 0, 0, 0,				// RGBAJ[obt@̃rbg
			0, 0, 0, 0, 0,						// AL[Vobt@̃sNZ̃rbg
			32,									// fvXobt@    ̃sNZ̃rbg
			0,									// XeVobt@̃sNZ̃rbg
			0,									// ⏕obt@      ̃sNZ̃rbg
			PFD_MAIN_PLANE,						// C[^Cv
			0,									// 
			0,									// 
			0,									// 
			0									// 
		};
	    
		if ( 0 == (pixelformat = ChoosePixelFormat (hdc, &pfd)) )
		{
			return 1;
		}

		if ( FALSE == SetPixelFormat(hdc, pixelformat, &pfd) )
		{
			return 2;
		}

		return 0;
	}

	// OC^[tFCX
	// -----------------------------------------------------------------------

	// 
	void *InitGL( System::IntPtr hWnd )
	{
		return new Glwc((HWND)hWnd.ToInt32());
	}


	// J
	void  DestroyGL(void*p)
	{
		delete (Glwc*)p;
	}
}
