// ---------------------------------------------------------------------------
// GLWC.h
// Copyright (c) 2006 NAKA Takatoshi. All rights reserved.
// ---------------------------------------------------------------------------

#pragma once

namespace glcall
{
	class Glwc
	{
	private:
		HWND   _hWnd;
		HDC    _hDC;
		HGLRC  _hglrc;

		int SetupPixelFormat( HDC hdc );
	public:
		Glwc( HWND hWnd );
		~Glwc();

		void BeginRender();
		void EndRender();

		void SetCurrent();
	};

	inline void Glwc::SetCurrent()
	{
		wglMakeCurrent( _hDC, _hglrc );
	}

	inline void Glwc::BeginRender()
	{
		wglMakeCurrent( _hDC, _hglrc );
	}
	
	inline void Glwc::EndRender()
	{
		SwapBuffers( _hDC );
		wglMakeCurrent( _hDC, 0);
	}
}
