// ---------------------------------------------------------------------------
// MyRender.cpp
// Copyright (c) 2006 NAKA Takatoshi. All rights reserved.
// ---------------------------------------------------------------------------

#include "stdafx.h"
#include <windows.h>
//#include <GL/gl.h>
//#include <GL/glu.h>
#include <glut.h>
#include "glmfc/GLWC.h"
#include "og/og.h"
#include "cube.h"

double bluec = 0.0;
double redc = 1.0;
bool observation_t;
bool thredflag = false;
//--------------------O[oϐ----------------------

int CubeSize;
CCube_ISO *Cube = NULL;
CCube_ISO InCube;
char filename_a[200];

double Intensity = 0.5;
double Ratio = 0.5;
double checkI = 0.4;
double checkR = 0.4;

int mouseX=0, mouseY=0;
int barX=360, barY=360, barXY=360;
int rotateX=0, rotateY=0, rotateXY=0;

double distance=50.0;
int distanced = 0;

ogVector viewdirection;

int PointSize = 1;	//point size for draw mode point
//int drawtype = 5;	//draw mode default(0:cloud 1:iso-surface-cloud 2:point 3:iso-surface 4:wireframe 5:non)
int bondflag=1;		//draw bond flag default(0:OFF 1:ON)

void alphaSet(bool type);
void sizeSet(int size);
void barSet(int x, int y, int z, int xy);
void mallocCube(int size );
int loadCubeSet(char *filename, int num);
void observation_type(bool t);
float max_value(void);
float min_value(void);


void MyInitRender( void *p )
{
	glcall::Glwc *pGL = (glcall::Glwc*)p;
	
	// _O ReLXgJgɂ
	pGL->SetCurrent();

//----------------------------------------

	// wiF
//	glClearColor(1.0f, 1.0f, 1.0f, 1.0f) ;
//	glClearColor(0.0f, 0.0f, 0.0f, 1.0f) ;

	/// [xobt@
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
/*
	char filename[128];
	for( int i=0; i<CubeSize; i++ ){
		sprintf( filename, "data/sh0homo.m%03d.cube", i*30 );
//		sprintf( filename, "data/cube[000].bin");
		Cube[i].construct( filename, 1000.0, 1.0 );
	}
*/
	og.LookAt( 0, 0, -distance,  0, 0, 0,  0, 1, 0 );
}

void MyRender( void *p, float dt, int w, int h )
{
	glcall::Glwc *pGL = (glcall::Glwc*)p;

	// `Jn
	pGL->BeginRender();


//-----------------------------------------

	// `͈͂̐ݒ
	og.Viewport( 0, 0, w, h );
	og.Perspective( 45.0, 1.0, 10000.0);

//	og.LookAt( 0, 0, -distance,  0, 0, 0,  0, 1, 0 ); //eye, center, up

	og.RotateEyePositionUp(PI*rotateY/180.0);
	og.RotateEyePositionRight(PI*rotateX/180.0);
	og.TwistEyeRight(PI*rotateXY/180.0);

	ogVector v = og.eye-og.center;
	v.normalize();
	v*=(double)distance;
	og.eye = og.center + v;

//	og.ZoomUp( (double)distanced/10.0 );
//	SlideEyePositionRight
	og.GouraudShading();
	og.ZBufferOn();

	// ŏ̓hԂ
//	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
	og.Clear(0,0,0);


	// ˉes̐ݒ
//	glMatrixMode(GL_PROJECTION);
//	glLoadIdentity();
//	gluPerspective(40, (float)w/(float)h, 0.1, 200);
	

	// J̐ݒ
//	glMatrixMode(GL_MODELVIEW);
//	glLoadIdentity();
//	glTranslated( 0.0, 0.0, -5.0 );

	if(Cube != NULL){
		int cubeNumber = (int)(Ratio * (CubeSize-1));
		double ratio = Ratio * (CubeSize-1) - cubeNumber;//0.01-0.99

		og.ZBufferOn();
		glDisable( GL_TEXTURE_2D );
		glDisable( GL_BLEND );

		og.LightOff();
		Cube[cubeNumber].drawFrame( 255, 255, 255 );

		og.LightOn(100.0, 100.0, 100.0, 0.7,0.7,0.7, 0.3,0.3,0.3, 0.3,0.3,0.3, 10.0);
		if(bondflag==1){
			Cube[cubeNumber].drawAtoms( ratio, Cube[cubeNumber+1] );
			Cube[cubeNumber].drawBonds( ratio, Cube[cubeNumber+1] );
		}

		viewdirection=og.GetViewDirection();

		if(!thredflag){
			Cube[cubeNumber].DrawOrbit(drawtype, Cube[cubeNumber+1], ratio, Intensity,
				  viewdirection, &InCube, &checkR, &checkI,
				  PointSize, ISO_MAX);
		}
	}
	// I
	glFlush();
	pGL->EndRender();
}

void Colorset(double r, double b )
{
	redc = r;
	bluec = b;
}
void ratioSet(int r){
	Ratio = double(r)/255.0;
	if(Ratio>=0.99)Ratio=0.99;

}
float valueSet(int v){
	ISO_MAX = v;
	ISO_MIN = ISO_MAX - 15;
	if(ISO_MIN<=0) ISO_MIN = 1;
	return convert_itof(v);
}
int valueSet(float v){
	ISO_MAX = convert_ftoi(v);
	ISO_MIN = ISO_MAX - 15;
	if(ISO_MIN<=0) ISO_MIN = 1;
	return ISO_MAX;
}
void drawtypeSet(void *p, int type, System::Windows::Forms::ProgressBar * pb, int num, float max, float min){

	thredflag = true;
	drawtype = type;
	int draw_flag = d_type;

	if(type==0){
		pb->Value = 0;
		glcall::Glwc *pGL = (glcall::Glwc*)p;
		pGL->BeginRender();
		if(observation_t==false){
			mallocCube(2);
			for(int i=0;i<2;i++)loadCubeSet(filename_a, i);
		}
		d_type=TYPE_C;
		for(int i=0;i<CubeSize;i++){	
			if(Cube[i].texName == NULL) Cube[i].texImage();
			else if(d_type==draw_flag){}
			else {
				free(Cube[i].texName);
				Cube[i].texName=NULL;
				Cube[i].texImage();
			}
			pb->Value = int(((double)(i+1) / (double)CubeSize)*100);
			pb->Refresh();
		}
		pGL->EndRender();
	}
	if(type==1){
		pb->Value = 0;
		int isov=ISO_MAX;
		glcall::Glwc *pGL = (glcall::Glwc*)p;
		pGL->BeginRender();
		if(CubeSize!=num){ 
			mallocCube(num);
			for(int i=0;i<num;i++)loadCubeSet(filename_a, i);
		}
		d_type=TYPE_I;
		for(int i=0;i<CubeSize;i++){
			if(observation_t==false){
				ISO_MAX=(int)((double)(i)/(double)(CubeSize-1)*(convert_ftoi(max)-convert_ftoi(min)));
				ISO_MAX+=convert_ftoi(min);
			}
			if(Cube[i].texName == NULL) Cube[i].texImage();
			else if(d_type==draw_flag){}
			else {free(Cube[i].texName); Cube[i].texName=NULL; Cube[i].texImage();}
			pb->Value = int(((double)(i+1) / (double)CubeSize)*100);
			pb->Refresh();
		}
		ISO_MAX=isov;
		pGL->EndRender();
	}
	thredflag = false;
}
void alphaSet(bool type){
	alpha_on = (int)type;
}

void bondSet(bool type){
	bondflag = (int)type;
}

void sizeSet(int size){
	PointSize = size;
}
void barSet(int x, int y, int z, int xy){
//	barX = x-360;
//	barY = y-360;
//	distance = -(z-100);
//	barXY = xy-360;
	if(x!=barX){rotateX=barX-x; barX = x;}
	else rotateX = 0;
	if(y!=barY){rotateY=y-barY; barY = y;}
	else rotateY = 0;
	if(xy!=barXY){rotateXY=xy-barXY; barXY = xy;}
	else rotateXY = 0;
	if(z!=(int)distance){distanced=z-distance; distance = z;}
	else distanced = 0;
}

void mallocCube(int size ){
	if(Cube != NULL) free(Cube);
	Cube = (CCube_ISO *)malloc(sizeof(CCube_ISO) * size);
	CubeSize = size;
}

int checkCube(void){
	if(Cube == NULL) return 1;
	return 0;
}

int loadCubeSet(char *filename, int num){
	int result=1;
/*
	char filename2[200];
	strcpy(filename2,filename);
	Cube[num].construct();
	result = Cube[num].load(filename);
	for(int i=0;filename2[i]!='\0';i++);
	filename2[i-4]='b';
	filename2[i-3]='i';
	filename2[i-2]='n';
	filename2[i-1]='\0';
	Cube[num].save(filename2);
	Cube[num].convert();
*/
	result = Cube[num].construct( filename, 1000.0, 1.0 );
	if(strcmp(filename, filename_a)!=0)strcpy(filename_a, filename);
	return result;
}
void observation_type(bool t){
	observation_t = t;
}
float max_value(void){
	return maxv;
}
float min_value(void){
	return minv;
}
void defaultsetting(void){
	rotateX=0; rotateY=0; rotateXY=0;
	barX=360; barY=360; barXY=360;
	distance=50.0; distanced=0;
	og.LookAt( 0, 0, -distance,  0, 0, 0,  0, 1, 0 );
}